/***************************************************************************
                          semrm.c  -  semaphore remover program, removes
                          the semaphore array allocated by seminit program

 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>

int main()
{
  key_t key;
  int semid;
  int i;
  
  union semun
  {
    int val;                    /* value for SETVAL */
    struct semid_ds *buf;       /* buffer for IPC_STAT, IPC_SET */
    unsigned short int *array;  /* array for GETALL, SETALL */
    struct seminfo *__buf;      /* buffer for IPC_INF */
  } arg;

  if ( (key = ftok("seminit.c", 'J')) == -1 )
  {
    perror( "ftok" );
    exit( 1 );
  }

  /* grab the semaphore set created by seminit.c */
  if ( (semid = semget(key, 1, 0)) == -1 )
  {
    perror( "semget" );
    exit( 1 );
  }

  /* remove it */
  if ( semctl(semid, 0, IPC_RMID, arg) == -1 )
  {
    perror( "semctl" );
    exit( 1 );
  }

  return 0;
}

